Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1057634 - Improved depending collections support
Summary: Improved depending collections support
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: scl-utils
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Panu Matilainen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1062125
TreeView+ depends on / blocked
 
Reported: 2014-01-24 14:16 UTC by Vít Ondruch
Modified: 2019-04-05 03:04 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1062125 (view as bug list)
Environment:
Last Closed: 2016-07-19 10:55:03 UTC


Attachments (Terms of Use)

Description Vít Ondruch 2014-01-24 14:16:05 UTC
For better support of depending collections, it would be cool if scl-utils could provide some macro support for the idea bellow, to remove the repetitive work.


scl depending collections
-------------------------------------
- split %scl into %scl_name_base, %scl_name_version
- each metapackage has subpackage named "scldevel"
- this package is added into minimal buildroot by relengs
- this subpackage must contain macros.%{scl_name_base}-scldevel that must contain:

cat >> %{buildroot}%{_root_sysconfdir}/rpm/macros.%{scl_name_base}-scldevel << EOF
%%scl_%{scl_name_base} %{scl}
%%scl_prefix_%{scl_name_base} %{scl_prefix}
EOF

- the macros.%{scl_name_base}-scldevel files must conflict between all %{scl_name_base} collections. This disallows installation of multiple versions of %{scl_name_base} collections (e.g. ruby193-scldevel can't be installed side by side with ruby200-scldevel):

%package scldevel
Summary: Package shipping development files for %scl
%description scldevel
Package shipping development files, especially usefull for development of
packages depending on %scl Software Collection.


- Usage
Everything bellow belongs into metapackage of dependent collection

# This is optional. Can be replaced by %{?scl_prefix_ruby}. It is just hint,
# that the collection was designed with ruby200 in mind. If buildroot has no
# special settings (i.e. there is explicitely not available different -scldevel
# package), the BuildRequires pulls in ruby200-scldevel.
%{!?scl_ruby:%global scl_ruby ruby200}
%{!?scl_prefix_ruby:%global scl_prefix_ruby %{scl_ruby}-}

# Always BR -scldevel package. That way you ensure that -scldevel packag is in
# buildroot and the default values are actually not in use. When this package
# would be omitted, it might result in broken requires, which could be
# discoverred just by build of subsequent packages.
BuildRequires: %{scl_prefix_ruby}scldevel

%package runtime
Summary: Package that handles %scl Software Collection.
Requires: scl-utils
Requires: %{scl_prefix_ruby}runtime

%package build
Summary: Package shipping basic build configuration
# This ensures availability of macros in every package of collection.
Requires: %{scl_prefix_ruby}scldevel

Comment 2 Jan Zeleny 2014-01-24 14:21:55 UTC
Sounds like an interesting and doable idea, I will look into it.

Comment 3 Jan Zeleny 2014-04-08 11:53:50 UTC
Upstream ticket:
https://fedorahosted.org/SoftwareCollections/ticket/14

Comment 4 Jaroslav Reznik 2015-03-03 16:58:40 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22

Comment 5 Fedora Admin XMLRPC Client 2016-05-30 14:58:53 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 6 Fedora End Of Life 2016-07-19 10:55:03 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 7 Vít Ondruch 2016-07-19 12:17:20 UTC
We are using this approach for SCLs already, but it would be nice to have better support in scl-utils, since this is just boilerplate for every collection.

Comment 9 Fedora Admin XMLRPC Client 2016-10-12 08:02:14 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.


Note You need to log in before you can comment on or make changes to this bug.